﻿using System;
using System.Collections.Generic;

using Xamarin.Forms;

namespace BindingTest
{
	public partial class SpaceViewerPage : ContentPage
	{
		public SpaceViewerPage ()
		{
			InitializeComponent ();
			var viewModel = new SpaceViewerViewModel ();
			viewModel.FrameworkBindingAreWorkingFineText = "initial";
			viewModel.CurrentSpace = new Space ("test", Color.Blue) {
			};
			BindingContext = viewModel;

		}

		public void OnTestClicked (object s, EventArgs e)
		{
			ViewModel.FrameworkBindingAreWorkingFineText = "changed";
			ViewModel.CurrentSpace = new Space ("test", Color.Red) {
			};
		}


		public void OnManuallySetSpaceClicked (object s, EventArgs e)
		{
			SpaceLayout.CurrentSpace = new Space ("test", Color.Green) {
			};
		}


		protected override void OnBindingContextChanged ()
		{
			base.OnBindingContextChanged ();
			ViewModel.PropertyChanged += (sender, e2) => {
				var name = e2.PropertyName;
				DebugLabel.Text += ", propertyChange[" + name + "] ";
			};
		}

		public SpaceViewerViewModel ViewModel {
			get{ return (SpaceViewerViewModel)BindingContext; }
		}
	}
}

